$(function() {
    $("select").chosen();
    $('.chosen-drop, .chosen-container').css({minWidth: '100%', width: 'auto'});
});

$(function() {
    var button = $(".submit_new");
    var form = button.parents('form:first');
    button.click(function () {
        form.attr('action', '?new=true');
    });
    form.attr('action', '?show=true');
});

$(function() {
    var forwardInput = $('#forward');
    var forwardBox = $('#forwardDomain').parent();
    var forceRouteInput = $('#forceRoute');
    var forceRouteBox = $('#forceRouteHost').parent();
    var domainBinInput = $('#domainBin');
    var domainBinBox = $('#domainBinAddress').parent();
    var outboundInput = $('#customOutbound');
    var outboundBox = $('#outbound-box');
    var outboundIPInput = $('#outboundIP');
    var outboundEhloInput = $('#outboundEhlo');

    function toggleForward() {
        forwardBox.toggle(forwardInput.is(':checked'));
    }

    function toggleForceRoute() {
        forceRouteBox.toggle(forceRouteInput.is(':checked'));
    }

    function toggleDomainBin() {
        domainBinBox.toggle(domainBinInput.is(':checked'));
    }

    function toggleOutbound() {
        let v = outboundInput.is(':checked');
        outboundBox.toggle(v);
        if (!v) {
            outboundIPInput.val("");
            outboundEhloInput.val("");
        }
    }

    toggleForward();
    toggleForceRoute();
    toggleDomainBin();

    if (outboundIPInput.val() || outboundEhloInput.val()) {
        outboundInput.prop('checked', 'checked');
    }
    toggleOutbound();

    forwardInput.click(toggleForward);
    forceRouteInput.click(toggleForceRoute);
    domainBinInput.click(toggleDomainBin);
    outboundInput.click(toggleOutbound);

    function checkIDN() {
        var name = document.getElementById('name').value;
        var alert = $('#alert');
        var puny = punycode.toASCII(name);
        if (puny !== name) {
            alert.toggle(true);
            alert.text('{{ 'domain.idn_notice'|trans }} ' + puny);
        } else {
            alert.toggle(false);
        }
    }

    checkIDN();
    $('#name').keyup(checkIDN);

    /// aditionals open
    let dlink = $('#domain-additionals-link');
    let dbox = $('#domain-additionals');
    let ddir = $('#direction');
    let ddes = $('#domain-additionals-description')

    function openAdditionals() {
        dbox.toggle(true);
        dlink.off('click');
        dlink.click(closeAdditionals);
        ddir.html("▼");
        ddes.toggle(false);
    }

    function closeAdditionals() {
        dbox.toggle(false);
        dlink.off('click');
        dlink.click(openAdditionals);
        ddir.html("▶");
        ddes.toggle(true);
    }

    // open additionals if there is something set
    let dempty = true;

    dbox.find("input:not([type='checkbox'])").each(function (i, el) {
        if ($(el).val().length > 0) {
            dempty = false;
        }
    })
    dbox.find("input[type='checkbox']:checked").each(function (i, el) {
        dempty = false;
    })

    dempty ? closeAdditionals() : openAdditionals();
});
